/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology	5th	Rd.
 * Science-based Industrial	Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2006, Ralink Technology, Inc.
 *
 * All rights reserved.	Ralink's source	code is	an unpublished work	and	the
 * use of a	copyright notice does not imply	otherwise. This	source code
 * contains	confidential trade secret material of Ralink Tech. Any attemp
 * or participation	in deciphering,	decoding, reverse engineering or in	any
 * way altering	the	source code	is stricitly prohibited, unless	the	prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	aironet.h

	Abstract:

	Revision History:
	Who			When			What
	--------	----------		----------------------------------------------
	Name		Date			Modification logs
	Paul Lin	06-08-08		Initial
*/

#ifndef	__WSC_H__
#define	__WSC_H__

//Messages for the WSC state machine,
#define	WSC_MACHINE_BASE	34
#define	WSC_EAP_REQ_MSG		34
#define	WSC_EAP_RSP_MSG		35
#define	WSC_EAP_FAIL_MSG	36

#define	MAX_WSC_MSG			5

// WSC OUI SMI
#define WSC_OUI				0x0050f204
#define	WSC_SMI				0x00372A
#define	WSC_VENDOR_TYPE		0x00000001

// EAP code
#define	EAP_CODE_REQ		0x01
#define	EAP_CODE_RSP		0x02
#define	EAP_CODE_FAIL		0x04
#define EAP_TYPE_ID			0x01
#define EAP_TYPE_NOTIFY		0x02
#define	EAP_TYPE_WSC		0xfe

// WSC Opcode
#define	WSC_OPCODE_START		0x01
#define	WSC_OPCODE_ACK			0x02
#define	WSC_OPCODE_NACK			0x03
#define	WSC_OPCODE_MSG			0x04
#define	WSC_OPCODE_DONE			0x05
#define	WSC_OPCODE_FRAG_ACK		0x06

// Wsc EAP Messges type received from AP
#define	WSC_MSG_EAP_REQ_ID			0x21	
#define	WSC_MSG_EAP_REQ_START		0x22	
#define	WSC_MSG_EAP_FAIL			0x23	
#define	WSC_MSG_BEACON				0x01	// Use the definition in WSC_IE_MSG_TYPE
#define	WSC_MSG_PROB_REQ			0x02
#define	WSC_MSG_PROB_RSP			0x03
#define	WSC_MSG_M1					0x04
#define	WSC_MSG_M2					0x05
#define	WSC_MSG_M2D					0x06
#define	WSC_MSG_M3					0x07
#define	WSC_MSG_M4					0x08
#define	WSC_MSG_M5					0x09
#define	WSC_MSG_M6					0x0A
#define	WSC_MSG_M7					0x0B
#define	WSC_MSG_M8					0x0C
#define	WSC_MSG_WSC_ACK				0x0D
#define	WSC_MSG_WSC_NACK			0x0E
#define	WSC_MSG_WSC_DONE			0x0F
#define	WSC_MSG_UNKNOWN				0xff

// WSC connection mode
#define	WSC_PIN_MODE		0x01//0x10000000
#define	WSC_PBC_MODE		0x02//0x20000000

// WSC IE definitions
#define	WSC_IE_AP_CHANNEL			0x1001
#define	WSC_IE_ASSOC_STATE			0x1002
#define	WSC_IE_AUTH_TYPE			0x1003
#define	WSC_IE_AUTH_TYPE_FLAG		0x1004
#define	WSC_IE_AUTHENTICATOR		0x1005
#define	WSC_IE_CONF_MTHD			0x1008
#define	WSC_IE_CONF_ERROR			0x1009
#define	WSC_IE_CONF_URL4			0x100A
#define	WSC_IE_CONF_URL6			0x100B
#define	WSC_IE_CONN_TYPE			0x100C
#define	WSC_IE_CONN_TYPE_FLAG		0x100D
#define	WSC_IE_CREDENTIAL			0x100E
#define	WSC_IE_ENCR_TYPE			0x100F
#define	WSC_IE_ENCR_TYPE_FLAG		0x1010
#define	WSC_IE_DEV_NAME				0x1011
#define	WSC_IE_DEV_PASS_ID			0x1012
#define	WSC_IE_E_HASH_1				0x1014
#define	WSC_IE_E_HASH_2				0x1015
#define	WSC_IE_E_SNonce_1			0x1016
#define	WSC_IE_E_SNonce_2			0x1017
#define	WSC_IE_ENCR_SETTING			0x1018
#define	WSC_IE_EN_NONCE				0x101A
#define	WSC_IE_FEATURE_ID			0x101B
#define	WSC_IE_ID					0x101C
#define	WSC_IE_ID_PROOF				0x101D
#define	WSC_IE_KWRAP_AUTH			0x101E
#define	WSC_IE_KEY_ID				0x101F
#define	WSC_IE_MAC_ADDR				0x1020
#define	WSC_IE_MANUFACTURER			0x1021
#define	WSC_IE_MSG_TYPE				0x1022
#define	WSC_IE_MODEL_NAME			0x1023
#define	WSC_IE_MODEL_NO				0x1024
#define	WSC_IE_NETWORK_IDX			0x1026
#define	WSC_IE_NETWORK_KEY			0x1027
#define	WSC_IE_NETWORK_KEY_IDX		0x1028
#define	WSC_IE_NEW_DEV_NAME			0x1029
#define	WSC_IE_NEW_PASSWD			0x102A
#define	WSC_IE_OOB_DEV_PASSWD		0x102C
#define	WSC_IE_OS_VER				0x102D
#define	WSC_IE_POWER_LVL			0x102F
#define	WSC_IE_PSK_CURRENT			0x1030
#define	WSC_IE_PSK_MAX				0x1031
#define	WSC_IE_PUBLIC_KEY			0x1032
#define	WSC_IE_RADIO_ENABLE			0x1033
#define	WSC_IE_REBOOT				0x1034
#define	WSC_IE_REG_CURRENT			0x1035
#define	WSC_IE_REG_EST				0x1036
#define	WSC_IE_REG_LIST				0x1037
#define	WSC_IE_REG_MAX				0x1038
#define	WSC_IE_REG_NONCE			0x1039
#define	WSC_IE_REQ_TYPE				0x103A
#define	WSC_IE_RSP_TYPE				0x103B
#define	WSC_IE_RF_BAND				0x103C
#define	WSC_IE_R_HASH_1				0x103D
#define	WSC_IE_R_HASH_2				0x103E
#define	WSC_IE_R_SNONCE_1			0x103F
#define	WSC_IE_R_SNONCE_2			0x1040
#define	WSC_IE_SEL_REG				0x1041
#define	WSC_IE_SERIAL				0x1042
#define	WSC_IE_STATE				0x1044
#define	WSC_IE_SSID					0x1045
#define	WSC_IE_TOTAL_NET			0x1046
#define	WSC_IE_UUID_E				0x1047
#define	WSC_IE_UUID_R				0x1048
#define	WSC_IE_VENDOR_EXT			0x1049
#define	WSC_IE_VERSION				0x104A
#define	WSC_IE_X_509_CERT_REQ		0x104B
#define	WSC_IE_X_509_CERT			0x104C
#define	WSC_IE_EAP_ID				0x104D
#define	WSC_IE_MSG_COUNTER			0x104E
#define	WSC_IE_PUBLIC_KEY_HASH		0x104F
#define	WSC_IE_REKEY_KEY			0x1050
#define	WSC_IE_KEY_LIFETIME			0x1051
#define	WSC_IE_PERM_CFG_MTHD		0x1052
#define	WSC_IE_REG_CFG_MTHD			0x1053
#define	WSC_IE_PRI_DEV_TYPE			0x1054
#define	WSC_IE_SEC_DEV_TYPE_LIST	0x1055
#define	WSC_IE_PORTABLE_DEV			0x1056
#define	WSC_IE_AP_SETUP_LOCK		0x1057
#define	WSC_IE_APP_LIST				0x1058
#define	WSC_IE_EAP_TYPE				0x1059
#define	WSC_IE_INIT_VECTOR			0x1060
#define	WSC_IE_KEY_PRO_AUTO			0x1061
#define	WSC_IE_WSC_802_1X_ENABLE	0x1062

// Value of WSC_IE_DEV_PASS_ID 0x1012
#define	DEV_PASS_ID_PIN				0x0000
#define	DEV_PASS_ID_USER			0x0001
#define	DEV_PASS_ID_MACHINE			0x0002
#define	DEV_PASS_ID_REKEY			0x0003
#define	DEV_PASS_ID_PBC				0x0004
#define	DEV_PASS_ID_REG				0x0005

// Common definition
#define	WSC_VERSION					0x10

// Wsc status code
#define	STATUS_WSC_NOTUSED						0x0000
#define	STATUS_WSC_IDLE							0x0001
#define	STATUS_WSC_START_ASSOC					0x0002		// Begin associating to WPS AP
#define	STATUS_WSC_LINK_UP						0x0003		// Associated to WPS AP
#define	STATUS_WSC_EAPOL_START_SENT				0x0004		// Sending EAPOL-Start
#define	STATUS_WSC_EAP_REQ_ID_SENT				0x0005		// Sending EAP-Rsp(ID)
#define	STATUS_WSC_EAP_REQ_WSC_START			0x0006		// Receive EAPReq WPS_Start
#define	STATUS_WSC_EAP_M1_SENT					0x0007		// Sending M1
#define	STATUS_WSC_EAP_M2_RECEIVED				0x0008		// Received M2
#define	STATUS_WSC_EAP_M2D_RECEIVED				0x0009		// Received M2D
#define	STATUS_WSC_EAP_RSP_ACK_SENT				0x000A		// Sending EAP Response (ACK)
#define	STATUS_WSC_EAP_M3_SENT					0x000B		// Sending M3
#define	STATUS_WSC_EAP_M4_RECEIVED				0x000C		// Received M4
#define	STATUS_WSC_EAP_M5_SENT					0x000D		// Sending M5
#define	STATUS_WSC_EAP_M6_RECEIVED				0x000E		// Received M6
#define	STATUS_WSC_EAP_M7_SENT					0x000F		// Sending M7
#define	STATUS_WSC_EAP_M8_RECEIVED				0x0010		// Received M8
#define	STATUS_WSC_EAP_RSP_DONE_SENT			0x0011		// Sending EAP Response (Done)
#define	STATUS_WSC_EAP_CONFIGURED				0x0012		// Configured
#define	STATUS_WSC_SCAN_AP						0x0013		// Scanning AP


// All error message dtarting from 0x0100
#define	STATUS_WSC_PBC_TOO_MANY_AP				0x0101		// Too many PBC AP avaliable
#define	STATUS_WSC_PBC_NO_AP					0x0102		// No PBC AP avaliable
#define	STATUS_WSC_EAP_FAIL_RECEIVED			0x0103		// Received EAP-FAIL
#define	STATUS_WSC_EAP_NONCE_MISMATCH			0x0104		// Receive EAP with wrong NONCE
#define	STATUS_WSC_EAP_INVALID_DATA				0x0105		// Receive EAP without integrity (Hmac mismatch)
#define STATUS_WSC_PASSWORD_MISMATCH			0x0106		// Error PIN Code (R-Hash mismatch)
#define	STATUS_WSC_EAP_REQ_WRONG_SMI			0x0107		// Receive EAP-Req with wrong WPS SMI Vendor Id
#define	STATUS_WSC_EAP_REQ_WRONG_VENDOR_TYPE	0x0108		// Receive EAPReq with wrong WPS Vendor Type


// Error message, UI stop querying
//#define	STATUS_WSC_INVALID_SSID					0x0201		// Invalid SSID/BSSID in PIN mode				//TODO: not used
//#define	STATUS_WSC_EAP_REQ_WRONG_SMI			0x0202		// Receive EAP-Req with wrong WPS SMI Vendor Id	//TODO: move to 0x01ff
//#define	STATUS_WSC_EAP_REQ_WRONG_VENDOR_TYPE	0x0203		// Receive EAPReq with wrong WPS Vendor Type	//TODO: move to 0x01ff
#define	STATUS_WSC_EAP_FAILED					0x0204		// WPS EAP process failed


// WSC Processing Timer
#define WSC_REG_SESSION_TIMEOUT					120000		// 2 min
#define	WSC_PER_MSG_TIMEOUT						15000		// 15 sec
#define	WSC_PROFILE_RETRY_TIMEOUT				10000		// add by johnli, 10 sec, fix WPS test plan 5.1.1


// WSC error messages
#define WSC_ERROR_NO_ERROR                		0x0000
#define WSC_ERROR_OOB_INT_READ_ERR        		0x0001
#define WSC_ERROR_DECRYPT_CRC_FAIL        		0x0002
#define WSC_ERROR_CHAN24_NOT_SUPP         		0x0003
#define WSC_ERROR_CHAN50_NOT_SUPP         		0x0004
#define WSC_ERROR_SIGNAL_WEAK             		0x0005
#define WSC_ERROR_NW_AUTH_FAIL            		0x0006
#define WSC_ERROR_NW_ASSOC_FAIL           		0x0007
#define WSC_ERROR_NO_DHCP_RESP            		0x0008
#define WSC_ERROR_FAILED_DHCP_CONF        		0x0009
#define WSC_ERROR_IP_ADDR_CONFLICT        		0x000A
#define WSC_ERROR_FAIL_CONN_REGISTRAR     		0x000B
#define WSC_ERROR_MULTI_PBC_DETECTED      		0x000C
#define WSC_ERROR_ROGUE_SUSPECTED         		0x000D
#define WSC_ERROR_DEVICE_BUSY             		0x000E
#define WSC_ERROR_SETUP_LOCKED            		0x000F
#define WSC_ERROR_MSG_TIMEOUT             		0x0010
#define WSC_ERROR_REG_SESSION_TIMEOUT     		0x0011
#define WSC_ERROR_DEV_PWD_AUTH_FAIL       		0x0012


// Authentication types
#define WSC_AUTHTYPE_OPEN        0x0001
#define WSC_AUTHTYPE_WPAPSK      0x0002
#define WSC_AUTHTYPE_SHARED      0x0004
#define WSC_AUTHTYPE_WPA         0x0008
#define WSC_AUTHTYPE_WPA2        0x0010
#define WSC_AUTHTYPE_WPA2PSK     0x0020

// Encryption type
#define WSC_ENCRTYPE_NONE    0x0001
#define WSC_ENCRTYPE_WEP     0x0002
#define WSC_ENCRTYPE_TKIP    0x0004
#define WSC_ENCRTYPE_AES     0x0008

#define WSC_MAX_RX_BUFFER			2048

// 802.1x authentication format
typedef	struct	_IEEE8021X_FRAME	{
	UCHAR	Version;					// 1.0
	UCHAR	Type;						// 0 = EAP Packet
	USHORT	Length;
}	IEEE8021X_FRAME, *PIEEE8021X_FRAME;

// EAP frame format
typedef	struct	PACKED	_EAP_FRAME	{
	UCHAR	Code;						// 1 = Request, 2 = Response
	UCHAR	Id;
	USHORT	Length;
	UCHAR	Type;						// 1 = Identity, 0xfe = reserved, used by WSC
}	EAP_FRAME, *PEAP_FRAME;

// WSC fixed information within EAP
typedef	struct	PACKED	_WSC_FRAME	{
	UCHAR	SMI[3];
	ULONG	VendorType;
	UCHAR	OpCode;
	UCHAR	Flags;
}	WSC_FRAME, *PWSC_FRAME;

// For WSC state machine states.
// We simplified it
typedef	enum	_WscState
{
	WSC_STATE_OFF,
	WSC_STATE_INIT,		
	WSC_STATE_START,
	WSC_STATE_CONN_FAIL,
	WSC_STATE_FAIL,	
	WSC_STATE_LINK_UP,
	WSC_STATE_WAIT_START,
	WSC_STATE_WAIT_M2,
	WSC_STATE_RX_M2D,	
	WSC_STATE_WAIT_M4,
	WSC_STATE_WAIT_M6,
	WSC_STATE_WAIT_M8,
	WSC_STATE_WAIT_EAPFAIL,
	WSC_STATE_WAIT_DISCONN,
	WSC_STATE_CONFIGURED,	
}	WSC_STATE;

// WSC IE structure
typedef	struct	PACKED	_WSC_IE
{
	USHORT	Type;
	USHORT	Length;
	UCHAR	Data[1];	// variable length data
}	WSC_IE, *PWSC_IE;

// WSC Mode for RaUI
typedef	struct	_WSC_MODE
{
	ULONG				WscMode;		// predefined WSC mode, 1: PIN, 2: PBC
	UCHAR				PIN[8];			// 8 bytes PIN nunmber
	NDIS_802_11_SSID	WscSSID;
	NDIS_802_11_MAC_ADDRESS Bssid;
	UCHAR				Channel;
	UCHAR				Reserved[1];
}	WSC_MODE, *PWSC_MODE;

// WSC saved message
typedef	struct	_WSC_MESSAGE
{
	ULONG	Length;			// Length of saved message
	UCHAR	Data[WSC_MAX_RX_BUFFER];		// Contents
}	WSC_MESSAGE, *PWSC_MESSAGE;

// Data structure to hold Enrollee and Registrar information
typedef struct	_WSC_DEV_INFO
{
	UCHAR	Version;
	UCHAR	Uuid[16];
	UCHAR	MacAddr[6];
	UCHAR	DeviceName[32];
	UCHAR	PriDeviceType[8];
	USHORT	AuthTypeFlags;
	USHORT	EncrTypeFlags;
	UCHAR	ConnTypeFlags;
	USHORT	ConfigMethods;
	UCHAR	ScState;
	UCHAR	Manufacturer[64];
	UCHAR	ModelName[32];
	UCHAR	ModelNumber[32];
	UCHAR	SerialNumber[32];
	UCHAR	RfBand;
	ULONG	OsVersion;
	ULONG	FeatureId;
	USHORT	AssocState;
	USHORT	DevPwdId;
	USHORT	ConfigError;
	UCHAR	Ssid[32];
	UCHAR	KeyMgmt[20];
}	WSC_DEV_INFO, *PWSC_DEV_INFO;

// data structure to store info of the instance of Registration protocol
typedef	struct	_WSC_REG_DATA
{
	// enrollee endpoint - filled in by the Registrar, NULL for Enrollee
	WSC_DEV_INFO	EnrolleeInfo;        
	// Registrar endpoint - filled in by the Enrollee, NULL for Registrar
	WSC_DEV_INFO	RegistrarInfo;    

	//Diffie Hellman parameters
//	BIGNUM		*DH_PubKey_Peer; //peer's pub key stored in bignum format
//	DH			*DHSecret;       //local key pair in bignum format
	UCHAR		EnrolleeRandom[192];	// Saved random byte for public key generation
	
	UCHAR		Pke[192];		//enrollee's raw pub key
	UCHAR		Pkr[192];		//registrar's raw pub key

	UCHAR		SecretKey[192];	// Secret key calculated by enrollee
	
	UCHAR		StaEncrSettings[128];		// to be sent in M2/M8 by reg & M7 by enrollee
	UCHAR		ApEncrSettings[1024];

	// Saved Message content for authenticator calculation
	WSC_MESSAGE	LastTx;
	WSC_MESSAGE	LastRx;

	// Device password
	UCHAR		PIN[8];

	// From KDF Key
	UCHAR		AuthKey[32];
	UCHAR		KeyWrapKey[16];
	UCHAR		Emsk[32];
	
	USHORT		EnrolleePwdId;
	UCHAR		EnrolleeNonce[16];		//N1
	UCHAR		RegistrarNonce[16];		//N2
	UCHAR		M2DRegistrarNonce[16];

	UCHAR		Psk1[16];
	UCHAR		Psk2[16];

	UCHAR		EHash1[32];
	UCHAR		EHash2[32];
	UCHAR		Es1[16];
	UCHAR		Es2[16];

	UCHAR		RHash1[32];
	UCHAR		RHash2[32];
	UCHAR		Rs1[16];
	UCHAR		Rs2[16];
}	WSC_REG_DATA, *PWSC_REG_DATA;

// WSC configured credential
typedef	struct	_WSC_CREDENTIAL
{
	NDIS_802_11_SSID	SSID;				// mandatory
	ULONG				AuthType;			// mandatory, 1: open, 2: wpa-psk, 4: shared, 8:wpa, 0x10: wpa2, 0x20: wpa2-psk
	ULONG				EncrType;			// mandatory, 1: none, 2: wep, 4: tkip, 8: aes
	ULONG				KeyIndex;			// optional, default is 1, but the value is 0
	ULONG				KeyLength;		
	UCHAR				Key[64];			// mandatory, Maximum 64 byte
	UCHAR				MacAddr[6];			// mandatory, AP MAC address
	UCHAR				Rsvd[2];			// Make alignment
//	UCHAR				EapType;			// optional, 8 bytes maximum
//	UCHAR				EapIdLength;		
//	UCHAR				EapId[64];			// optional, Maximum 64 byte
//	ULONG				KeyAuto;			// optional
//	ULONG				Enable1x;			// optional
}	WSC_CREDENTIAL, *PWSC_CREDENTIAL;

// WSC configured profiles for RaUI
typedef	struct	_WSC_PROFILE
{
	ULONG			ProfileCnt;
	UINT			ApplyProfileIdx;  // add by johnli, fix WPS test plan 5.1.1
	WSC_CREDENTIAL	Profile[8];				// Support up to 8 profiles
}	WSC_PROFILE, *PWSC_PROFILE;

/*typedef struct PACKED _WSC_CONFIGURED_VALUE 
{
	USHORT	WscConfigured; // 1 un-configured; 2 configured
	UCHAR	WscSsid[32 + 1];
	USHORT	WscAuthMode;	// mandatory, 0x01: open, 0x02: wpa-psk, 0x04: shared, 0x08:wpa, 0x10: wpa2, 0x20: wpa2-psk
	USHORT	WscEncrypType;	// 0x01: none, 0x02: wep, 0x04: tkip, 0x08: aes
	UCHAR	DefaultKeyIdx;
	UCHAR	WscWPAKey[64 + 1];
} WSC_CONFIGURED_VALUE;*/

// WSC control block
typedef	struct	_WSC_CTRL
{
	ULONG			WscMode;		// Saved WscMode predefined WSC mode, 1: PIN, 2: PBC
	ULONG			WscStatus;		// predefined WSC connection status
//	BOOLEAN			WscEnProfile;		// use wsc profile to do the connection
	BOOLEAN			WscEnAssociateIE;	// Add WSC IE on Associate frame.
	BOOLEAN			WscEnProbeReqIE;	// Add WSC IE on Probe-Req frame.
	UINT            WscPinCode;     // record the PIN code
	NDIS_802_11_SSID	WscSsid;		// select a desired ssid to connect for PIN mode 
	UCHAR			WscBssid[MAC_ADDR_LEN];	// select a desired bssid to connect for PIN mode
	BOOLEAN			WscTriggered;		// TRUE: Enrollee work, FALSE: Enrollee stop working
	UCHAR			WscKeyLen;
	UCHAR			WscKey[64];
	UCHAR			WscKeyType;		// 0: hex, 1:assic
	WSC_STATE		WscState;
	WSC_PROFILE		WscProfile;		// Saved WSC profile after M8
	BSS_TABLE		WscBssTab;		// AP list for the PBC activated
	WSC_REG_DATA		RegData;		// Registrar pair data
	RALINK_TIMER_STRUCT	WscConnectTimer, WscScanTimer, WscPBCTimer, WscPINTimer, WscEapRxTimer; 
//	RALINK_TIMER_STRUCT	WscEapM2Timer, WscM8WaitEapFailTimer;
	RALINK_TIMER_STRUCT	WscEapM2Timer, WscM8WaitEapFailTimer, WscEndTimer;  // edit by johnli
	RALINK_TIMER_STRUCT	WscProfileRetryTimer;  // add by johnli, fix WPS test plan 5.1.1
	void 			*pPubKeyMem;
	void			*pSecKeyMem;
}	WSC_CTRL, *PWSC_CTRL;


#endif	// __WSC_H__

